#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"



typedef struct Example__XSObject_ctx {
    unsigned int age;
    unsigned char *name;
} *Example__XSObject;


MODULE = Example::XSObject		PACKAGE = Example::XSObject		


Example::XSObject
new(class, ...)
    SV *class
    CODE:
    {

        Newz(0, RETVAL, 1, struct Example__XSObject_ctx);
        RETVAL->age  = 0;
        RETVAL->name = NULL;
    }
    OUTPUT:
        RETVAL

void
print(self)
    Example::XSObject self
    CODE:
    {
        printf("%s> %d\n", self->name, self->age);
    }


SV *
name(self, ...)
    Example::XSObject self
    CODE:
    {
        SV *value;

        /* $self->age($value) */
        if (items > 1) {
            value = ST(1);
            if (self->name != NULL)
                Safefree(self->name);
            Newz(0, self->name, SvCUR(value)+1, unsigned char);
            memmove(self->name, SvPVbyte(value, SvCUR(value)), SvCUR(value)+1);
        }
        RETVAL = NULL;
        if (self->name != NULL)
            RETVAL = newSVpv((char *)self->name, strlen((char *)self->name));
    }
    OUTPUT:
        RETVAL

SV *
age(self, ...)
    Example::XSObject self
    CODE:
    {
        SV *value;
        if (items > 1) {
            value = ST(1);
            self->age = sv_2iv(value);
        }
        RETVAL = newSViv(self->age);
    }
    OUTPUT:
        RETVAL

void
DESTROY(self)
    Example::XSObject self
    CODE:
    {
        if (self->name != NULL) {
            Safefree(self->name);
            self->name = NULL;
        }
        self->age = 0;
        Safefree(self);
    }

